/**
 * Noiz
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * noiz.c(main routine)
 */
#define BIOS_INLINE
#include <sys/bios.h>
#include <stdlib.h>

#include "noiz.h"

static Boolean loopf = TRUE;
static int arrowX;

#include "sincos.c"
#include "preferencesmanager.c"
#include "displaymanager.c"
#include "gamemanager.c"
#include "titlemanager.c"

static int StartApplication(void) {
  Boolean exist;
  lcd_set_segments(0x2);
  initDisplay();
  randomize();
  setBitmaps();
  exist = loadPreferences((char far *)&prefData, sizeof(prefData));
  if ( exist ) {
    arrowX = 1;
  } else {
    resetGameStatus();
    makePrefData();
    arrowX = 0;
  }
  initGame();
  gotoTitle();
}

static void StopApplication(void) {
  setLevelMissData();
  savePreferences((char far *)&prefData, sizeof(prefData));
}

/* event loop interval*/
#define INTERVAL 7

static void loop() {
  unsigned long startTick = sys_get_tick_count();
  unsigned loopTick;
  if ( gameStatus.status == GAME_IN_PROGRESS ) {
    handleGameStatus();
  } else {
    handleTitle();
  }
  loopTick = sys_get_tick_count()-startTick;
  if ( loopTick < INTERVAL ) {
    sys_wait(INTERVAL-loopTick);
  }
}

void main(int argc, char *argv[]) {
  StartApplication();
  while ( loopf ) {
    loop();
  }
  StopApplication();
  bios_exit();
}
