/**
 * Noiz
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * titlemanager.c(title display)
 */

#define MENU_X 8

static void drawTitle() {
  int i, x = 16;
  clearScreen();
  drawBitmapWd(BITMAP_TITLE_IDX, 17, 1, title_width, title_height);
  drawBitmap(BITMAP_NOW_IDX, x, 0, now_height);
  x--;
  for ( i=0 ; i<HISTORY_NUM ; i++ ) {
    if ( prefData.history[i].level > 0 ) {
      drawBitmap(BITMAP_LEVEL_IDX, x, 0, level_height);
      drawNum(prefData.history[i].level, x, 5);
      drawNum(prefData.history[i].miss, x, 10);
      drawBitmap(BITMAP_MISS_IDX, x, 14, miss_height);
      x--;
      if ( i == 0 ) x--;
    } else {
      break;
    }
  }
  drawBitmap(BITMAP_NEWGAME_IDX, MENU_X, 5, newgame_height);
  drawBitmap(BITMAP_CONTINUE_IDX, MENU_X-1, 5, continue_height);
  drawBitmap(BITMAP_QUIT_IDX, MENU_X-2, 7, quit_height);
}

static void gotoTitle() {
  setTitleBitmaps();
  drawTitle();
  gameStatus.status = TITLE;
  startPressed = TRUE;
}

static void startButtonPushed() {
  createScreenBuffer();
  startPressed = TRUE;
  getPrefData();
  startGame();
}

static Boolean keyPressed = TRUE;
static int arrowIdx = 0;
static int arrowBi[] = {0, 1, 2, 1};

static void handleTitle() {
  int key;
  key = key_press_check();
  if ( keyPressed ) {
    if ( key == 0 ) keyPressed = FALSE;
  } else {
    if ( key & (KEY_LEFT1 | KEY_LEFT2) ) {
      clearBitmap(MENU_X-arrowX, 3, 1);
      arrowX++;
      if ( arrowX > 2 ) arrowX = 0;
      keyPressed = TRUE;
    } else if ( key & (KEY_RIGHT1 | KEY_RIGHT2) ) {
      clearBitmap(MENU_X-arrowX, 3, 1);
      arrowX--;
      if ( arrowX < 0 ) arrowX = 2;
      keyPressed = TRUE;
    }
  }
  drawBitmap(BITMAP_ARROW_IDX + arrowBi[arrowIdx&3], MENU_X-arrowX, 3, 1);
  if ( key & (KEY_START | KEY_A | KEY_B) ) {
    if ( !startPressed ) {
      switch ( arrowX ) {
      case 0:
	resetGameStatus();
	makePrefData();
	startButtonPushed();
	break;
      case 1:
	startButtonPushed();
	break;
      case 2:
	loopf = FALSE;
	break;
      }
    }
  } else {
    startPressed = FALSE;
  }
  arrowIdx++;
}
